<template>
  <section class="container">
    <p class="disclaimer">
      Escolha suas preferências de armário para o sorteio
    </p>
    <specific-preference
      v-for="id in max"
      :key="id"
      :id="id"
      :places="places"
      :positions="positions"/>
  </section>
</template>

<script>
import SpecificPreferencev2 from '~/components/SpecificPreferencev2.vue'

export default {
  components: {
    SpecificPreferencev2
  },
  computed: {
    places() {
      return this.$store.getters.reserveData.places;
    },
    positions() {
      return this.$store.getters.reserveData.positions;
    },
    max() {
      if (this.positions !== null && this.places !== null)
        return (this.positions.length-1) * (this.places.length-1);
      return 0;
    }
  },
  beforeCreate() {
    let ins = this;

    this.$axios({
      url: 'http://localhost:3000/features',
      method: 'get',
      headers: {
        Authorization: `Bearer ${ins.$store.getters.authToken}`
      }
    })
      .then (res => {
        let payload = {};
        payload.places = [''].concat(res.data.places);
        payload.positions = [''].concat(res.data.positions);

        ins.$store.commit('setReserveFeatures', payload);
      })
      .catch (err => {
        // TO-DO:
        // O que fazer em caso de erro nessa request?
        console.log(err);
      });
  }
}
</script>
